// Initialize testing set functions

var digitScale = BigDecimal.maxDigits

var sets = []
sets[0] = function() {
	var response = []
	for (var m = -1; m <= 10; m++) {
		response[response.length] = m.toString()
		}
	response[response.length] = "NaN"
	response[response.length] = "Infinity"
	response[response.length] = "-Infinity"
	return response
	}

sets[1] = function() {
	// xxxx
	var response = []
	response[0] = BigDecimal.addZeroes
	response[1] = ((BigDecimal.maxSection / 2) - 1).toString()
	response[2] = (BigDecimal.maxSection / 2).toString()
	response[3] = (BigDecimal.maxSection - 1).toString()
	return response
	}

sets[2] = function(arg) {
	// xxxxyyyy.0000
	var arg2;
	if (arguments.length == 0) {
		arg2 = ""
		} else {
		arg2 = arg
		}
	var response = []
	var subset = sets[1]()
	for (var m = 0; m < 4; m++) {
		for (var n = 0; n < 4; n++) {
			response[response.length] = subset[m] + arg2 + subset[n]
			}
		}
	return response
	}

sets[3] = function() {
	// .xxxxyyyy
	var response = []
	var subset = sets[1]()
	for (var m = 0; m < 4; m++) {
		for (var n = 0; n < 4; n++) {
			response[response.length] = "." + subset[m] + subset[n]
			}
		}
	return response
	}

sets[4] = function() {return sets[2](".")}
// xxxx.yyyy

sets[5] = function() {return sets[2](BigDecimal.addZeroes)}
// xxxx0000yyyy

sets[6] = function() {return sets[2]("." + BigDecimal.addZeroes)}
// xxxx.0000yyyy

sets[7] = function() {return sets[2](BigDecimal.addZeroes + "." + BigDecimal.addZeroes)}
// xxxx0000.0000yyyy

// Initialize testing operations

var ops = []
ops[0] = {fname:"compareTo", opchar:"<=>", code:"CT"}
ops[1] = {fname:"add", opchar:"+", code:"A"}
ops[2] = {fname:"subtract", opchar:"-", code:"S"}
ops[3] = {fname:"multiply", opchar:"*", code:"M"}
ops[4] = {fname:"divide", opchar:"/", code:"D"}

var datasets = []

var oneTimeTest = true

function testSequence(tableArg) {
	if (alreadyRun) {
		return false
		}
	oneTimeTest = false
	var report = document.getElementById("report")
	var timeChecks = document.getElementById("timeChecks").checked
	report.value = "Began test sequence at " + new Date() + "\n"
	var tableSrc = document.getElementById(tableArg)
	var tCheck = tableSrc.tBodies[0].rows[0].cells[0].childNodes[0].checked

	// retrieve test series
	var testSeries = [], cell = null
	for (var x = 0; x < tableSrc.tBodies.length; x++) {
		for (var y = 1; y < tableSrc.tBodies[x].rows.length; y++) {
			for (var z = 1; z < tableSrc.tBodies[x].rows[y].cells.length; z++) {
				cell = tableSrc.tBodies[x].rows[y].cells[z]
				if (cell.childNodes[1].checked) {
					testSeries[testSeries.length] = cell.childNodes[0].getAttribute("value").split(";")
					testSeries[testSeries.length - 1].orig = cell.childNodes[0].getAttribute("value")
					}
				}
			}
		}

	// test series retrieved

	// generate XNS test harness tables
	var test_data = []
	for (var a = 0; a < testSeries.length; a++) {
		test_data[a] = []
		for (var b = 0; b < ops.length; b++) {
			if (ops[b].code == testSeries[a][1]) {
				var fname = ops[b].fname
				var opchar = ops[b].opchar
				}
			}
		test_data[a].testName = testSeries[a][0] + " " + opchar
		test_data[a].opchar = opchar

            var testSet = eval(testSeries[a][0])()
		for (b = 0; b < testSet.length; b++) {
			test_data[a][b] = []
			for (var c = 0; c < testSet.length; c++) {
				test_data[a][b][c] = []
				test_data[a][b][c].x = testSet[b]
				test_data[a][b][c].y = testSet[c]
				test_data[a][b][c].fname = fname
				}
			}
		}
	// finished generating test harness arrays
	report.value += "Test harness arrays created at " + new Date() + "\n"

	// retrieve functions to benchmark and test
	var testFuncs = []
	cell = null
	for (x = 0; x < tableSrc.tFoot.rows[0].cells.length; x++) {
		cell = tableSrc.tFoot.rows[0].cells[x]
		if (cell.childNodes[1].checked) {
			testFuncs[testFuncs.length] = cell.childNodes[0].getAttribute("value")
			}
		}
	var sourceColor = []
	for (x = 0; x < testFuncs.length; x++) {
		switch (testFuncs[x]) {
			case "java.math.BigDecimal":
			sourceColor[x] = "java"
			break;

			default:
			sourceColor[x] = testFuncs[x]
			}
		}
	// test functions retrieved

	for (a = 0; a < testFuncs.length; a++) {
		if ((testFuncs[a].substring(0,5) == "java.")&&(typeof java == "undefined")) {
			continue;
			}
		if ((testFuncs[a] == "BigDecimal")&&(typeof BigDecimal == "undefined")) {
			continue;
			}
	// begin test and mark time
		for (b = 0; b < test_data.length; b++) {
                  var totalTime = 0
			try {
				for (c = 0; c < test_data[b].length; c++) {
					for (var d = 0; d < test_data[b][c].length; d++) {
						var datacell = test_data[b][c][d]
						x = datacell.x
						y = datacell.y
						var opfunc = datacell.fname
		if (timeChecks) {
			var startMilli = new Date() * 1
			}
						var doNotGo = false
						if (testFuncs[a]!="java.math.BigDecimal") {
	                                    x = new window[testFuncs[a]](x)
      	                              y = new window[testFuncs[a]](y)
							} else {
							switch (x.toString()) {
								case "NaN":
								case "Infinity":
								case "-Infinity":
								doNotGo = true
								break;

								default:
								x = new java.math.BigDecimal(x)
								}

							switch (y.toString()) {
								case "NaN":
								case "Infinity":
								case "-Infinity":
								doNotGo = true
								break;

								default:
								y = new java.math.BigDecimal(y)
								}
							}
						if (!doNotGo) {
							if (opfunc != "divide") {
								z = x[opfunc](y)
								} else {
								if ((testFuncs[a] == "java.math.BigDecimal")&&(y.compareTo(ZERO) == 0)) {
									z = Number.NaN
									} else {
									z = x[opfunc](y, digitScale, 4)
									}
								}
							} else {
							z = "java Error"
							}
						// z = x["multiply"](y) = x.multiply(y)
		if (timeChecks) {
			var endMilli = new Date() * 1
                  totalTime += (endMilli - startMilli)
                  }

						datacell[datacell.length] = z.toString().substr(0,50)
						}
					}
				}
			catch(e) {
				report.value += "Test failure on " + testFuncs[a] + ":\n" + e + "\n"
				for (property in e) {
					report.value += "Error property '" + property + "' = '" + e[property] + "'\n"
					}
				report.value += "testFuncs[a] = " + testFuncs[a] + "\n"
				report.value += "dataset: " + b + "\n"
				report.value += "x = " + x + "\n"
				report.value += "op = " + opfunc + "\n"
				report.value += "y = " + y + "\n\n"
				return false;
				}
			}
		if (timeChecks) {
			report.value += "Elapsed milliseconds for test " + testFuncs[a] + ":  " + totalTime + "\n"
			}
		}
	if (testFuncs.length > 1) {
		report.value += "Began analysis of results at " + new Date() + "\n";
		try {
			for (b = 0; b < test_data.length; b++) {
				var table_pass = true
				for (c = 0; c < test_data[b].length; c++) {
					var row_text = test_data[b].testName
					var row_pass = true
					for (d = 0; d < test_data[b][c].length; d++) {
						datacell = test_data[b][c][d]
            	                  var check1 = new BigDecimal(datacell[datacell.length - 2])
						var check2 = new BigDecimal(datacell[datacell.length - 1])
						if (check1.compareTo(check2) == 0) {
							datacell.length = 1
							datacell[0] = "Pass"
							} else {
							row_pass = false
							}
						}
					if (row_pass) {
						test_data[b][c].length = 1
						test_data[b][c][0] = (row_text + " row passes")
						} else {
						table_pass = false
						}
					}
				if (table_pass) {
					test_data[b].length = 1
					test_data[b][0] = "Test " + test_data[b].testName + " passes."
					}
				}
			}
		catch(e) {
			report.value += "Test failure on " + testFuncs[a] + ":\n" + e + "\n"
			for (property in e) {
				report.value += "Error property '" + property + "' = '" + e[property] + "'\n"
				}
			report.value += "b = " + b + "\n"
			report.value += "c = " + c + "\n"
			report.value += "d = " + d + "\n"
			report.value += "data cell = " + test_data[b][c][d].toSource() + "\n"
			report.value += "k = " + k.toSource() + "\n"
			return false
			}
		}

	report.value += "Began visual output of tables at " + new Date() + "\n"

	for (a = 0; a < test_data.length; a++) {
		var dataset = document.createElement("dataset")
		opchar = document.createElement("op")
		opchar.appendChild(document.createTextNode(test_data[a].opchar))
		if (test_data[a].length == 1) {
			var datarow = document.createElement("datarow")
			datacell = document.createElement("datacell")
			datacell.appendChild(document.createTextNode(test_data[a][0]))
			datarow.appendChild(datacell)
			dataset.appendChild(datarow)
			} else {
			for (b = 0; b < test_data[a].length; b++) {
				datarow = document.createElement("datarow")
				for (c = 0; c < test_data[a][b].length; c++) {
					datacell = document.createElement("datacell")
					if (typeof test_data[a][b][c].x != "undefined") {
						x = document.createElement("input")
						y = document.createElement("input")

						x.appendChild(document.createTextNode(test_data[a][b][c].x))
						y.appendChild(document.createTextNode(test_data[a][b][c].y))

						datacell.appendChild(x)
						datacell.appendChild(opchar.cloneNode(true))
						datacell.appendChild(y)
						}

					for (d = 0; d < test_data[a][b][c].length; d++) {
						z = document.createElement("output")
						z.setAttribute("source", sourceColor[d])
						z.appendChild(document.createTextNode(test_data[a][b][c][d]))
						datacell.appendChild(z)
						}
					datarow.appendChild(datacell)
					}
				dataset.appendChild(datarow)
				}
			}
		document.documentElement.appendChild(dataset)
		document.documentElement.appendChild(document.createElementNS(xhtml_ns, "br"))
		}

	report.value += "Ended test sequence at " + new Date() + "\n\nReload page to prepare for new test."
	oneTimeTest = true
      alreadyRun = true
	return true
	}

if (typeof java != "undefined") {
	const ZERO = new java.math.BigDecimal(0)
	}

function testset0_1() {
   if (arguments.length == 1) {
      var r = new BigDecimal(arguments[0])
      } else {
      r = new BigDecimal()
      }
   if (r.xnsType == "BigDecimal") {
      var response = "isNegative: " + r.isNegative() + "\n"
      response+= "digitArray: " + r.digitArray.join() + "\n"
      response+= "decPtAfter: " + r.decPtAfter + "\n"
      } else {
      response = ""
      }
   response+= "value: \n" + r + "\nOriginal value: \n" + arguments[0] + "\n\n"

   var report = document.getElementById("report")
   report.value += response
   }

function testset0_2(testset0_Num, leftSide, rightSide) {
   var response = testset0_Num + ". " + leftSide + " " + leftSide.xnsType 
   response+= " compareTo " + rightSide + " " + rightSide.xnsType
   response+= " : " + leftSide.compareTo(rightSide) + "\n\n"
   var report = document.getElementById("report")
   report.value += response
   }

function testset0() {
   var c;

   var report = document.getElementById("report"), start = new Date()
   testset0_1()
   testset0_1(0)
   testset0_1(1234567)
   testset0_1(-1)
   testset0_1(.5)
   testset0_1(.1234567)
   testset0_1("-0")
   var n = ("0.555555555555555555555555555555555555555555555555")
   testset0_1(n)

   var j = ("0.999999999999999999999999999999999999999999999999")
   testset0_1(j)

   testset0_1("h") // Number.NaN testset0_

   testset0_2(0, BigDecimal.ZERO, BigDecimal.ZERO)
   testset0_2(1, BigDecimal.ZERO, BigDecimal.ONE)
   testset0_2(2, BigDecimal.ONE, BigDecimal.ONE.negate())

   testset0_2(3, BigDecimal.ZERO, 1)
   testset0_2(4, 0, BigDecimal.ONE)

   testset0_2(5, BigDecimal.ZERO, new BigDecimal(0.001))
   testset0_2(6, BigDecimal.ZERO, new BigDecimal("0.000000"))

   var one_third = new BigDecimal(".333333333333333333333333333333333333333333333333333333333333333")
   testset0_2(7, one_third, one_third)

   testset0_2(8, BigDecimal.ZERO, Number.NaN)
   testset0_2(9, BigDecimal.ZERO, new BigDecimal(Number.NaN))

   testset0_2(10, BigDecimal.ZERO, new BigDecimal(Infinity))
   testset0_2(11, BigDecimal.ZERO, new BigDecimal(-Infinity))
   testset0_2(12, new BigDecimal(Number.NaN), new BigDecimal(+Infinity))
   testset0_2(13, c = new BigDecimal(Number.NaN), c)

   var finish = new Date();
   report.value += "Elapsed time in milliseconds: " + (finish - start) + "\n\n"
   }

function buildTimeTest() {
   var set = sets[7](), js_start_time = new Date()
   for (var a = 0; a < set.length; a++) {
      for (var b = 0; b < set.length; b++) {
         var c = new BigDecimal(set[a]), d = new BigDecimal(set[b])
         }
      }
   var js_stop_time = new Date()
   if (typeof java != "undefined") {
      for (a = 0; a < set.length; a++) {
         for (b = 0; b < set.length; b++) {
            c = new java.math.BigDecimal(set[a]); d = new java.math.BigDecimal(set[b])
            }
         }
      }
   var java_stop_time = new Date()
   var pre = document.createElementNS(xhtml_ns, "pre")
   var pre_text = "BigDecimal time test:  " + (js_stop_time - js_start_time)
   if (typeof java != "undefined") {
      pre_text += "\njava.math.BigDecimal time test:  " + (java_stop_time - js_stop_time)
      }
   var report = document.getElementById("report")
   report.value += pre_text + "\n\n"
   }

function calcBigD() {
   oneTimeTest = true
   var x = document.getElementById("BigX").value;
   var op = document.getElementById("BigOp"); op = op[op.selectedIndex].value
   var y = document.getElementById("BigY").value;

   document.getElementById("JS_Z").value = (x * 1)[op](y * 1)
   try {
      if (typeof java != "undefined") {
         var x0 = new java.math.BigDecimal(x), y0 = new java.math.BigDecimal(y)
         switch (true) {
            case ((y0.compareTo(ZERO) == 0)&&(op == "divide")):
		var z = Number.NaN
		break

		case (op == "divide"):
		z = x0[op](y0, digitScale, 4)
		break;

		default:
		z = x0[op](y0)
		}		
         document.getElementById("Java_Z").value = z.toString()
         }
      }
   catch(e) {
      document.getElementById("Java_Z").value = "java Error" + e
      }

   var x1 = new BigDecimal(x), y1 = new BigDecimal(y)
   document.getElementById("BigZ").value = x1[op](y1)
   oneTimeTest = false
   }

window.onload = function() {
	var report = document.getElementById("report")
	var reportText = "XNS BigDecimal Test Harness\n"
	reportText += "version 1.0\n\n"

	reportText += "XNS Number version "
	var numVersion = new Number(0);
	numVersion = numVersion.xnsVersion
	reportText += numVersion + " available for testing\n"

	if (typeof BigDecimal != "undefined") {
		reportText += "XNS BigDecimal version "
		numVersion = BigDecimal.ZERO.xnsVersion
		reportText += numVersion + " available for testing\n"
		}
	reportText += "java object "
	if (typeof java == "undefined") {
		reportText += "un"
		}
	reportText += "available for testing\n\n"

	reportText += "Reload after each test.\n\n"
	report.value = reportText
	}

const xhtml_ns = "http://www.w3.org/1999/xhtml"
const xns_ns = "http://www.jslab/org/namespaces/xns"
var alreadyRun = false